#include <windows.h>
#include <winver.h>
#include <stdlib.h>

#ifndef __CROSS_COMPAT_LIB__
#define __CROSS_COMPAT_LIB__
#endif

#include "srllib.h"


/**
 ** Defines
 **/
#define  ATDV_ERRMSGP_ID     0
#define  ATDV_IOPORT_ID      1
#define  ATDV_IRQNUM_ID      2
#define  ATDV_LASTERR_ID     3
#define  ATDV_NAMEP_ID       4
#define  ATDV_SUBDEVS_ID     5
#define  sr_waitevt_ID       6
#define  sr_waitevtEx_ID     7
#define  sr_enbhdlr_ID       8 
#define  sr_dishdlr_ID       9
#define  sr_getboardcnt_ID  10
#define  sr_getevtdev_ID    11
#define  sr_getevttype_ID   12
#define  sr_getevtlen_ID    13
#define  sr_getevtdatap_ID  14
#define  sr_hold_ID         15
#define  sr_release_ID      16
#define  sr_getparm_ID      17
#define  sr_setparm_ID      18
#define  sr_NotifyEvent_ID  19
#define  sr_setlasterr_ID   20
#define  sr_putevt_ID       21


//
// function prototypes
//
static void  sr_dflt_setlasterr();
static long  sr_dflt_lasterr();
static long  sr_long_notimp();
static char *sr_null_notimp();


/**
 ** Typedefs
 **/
typedef void (*func_ptr)(void);
struct func_table {
   char     *fname;
   func_ptr  fptr;
};

typedef char *(*ptr_ATDV_ERRMSGP)( long ddd );
typedef long (*ptr_ATDV_IOPORT)( long ddd );
typedef long (*ptr_ATDV_IRQNUM)( long ddd );
typedef long (*ptr_ATDV_LASTERR)( long ddd );
typedef char *(*ptr_ATDV_NAMEP)( long ddd );
typedef long (*ptr_ATDV_SUBDEVS)( long ddd );
typedef long (*ptr_sr_waitevt)( long tmout );
typedef long (*ptr_sr_waitevtEx)( long *handlep, int count, long tmout, long *evthp );
typedef long (*ptr_sr_enbhdlr)( long ddd, unsigned long event_type, long (*hdlr)( unsigned long parm ));
typedef long (*ptr_sr_dishdlr)( long ddd, unsigned long event_type, long (*hdlr)( unsigned long parm ));
typedef long (*ptr_sr_getboardcnt)( char * brdname, int * brdcnt);
typedef long (*ptr_sr_getevtdev)(unsigned long event);
typedef long (*ptr_sr_getevttype)( unsigned long evthandle);
typedef long (*ptr_sr_getevtlen)( unsigned long evthandle);
typedef void *(*ptr_sr_getevtdatap)( unsigned long evthandle );
typedef long (*ptr_sr_hold)( void );
typedef long (*ptr_sr_release)( void );
typedef long (*ptr_sr_getparm)( long ddd, long parmid, void* valuep) ;
typedef long (*ptr_sr_setparm)( long ddd, long parmid, void* valuep );
typedef void (*ptr_sr_NotifyEvent)(HWND handle, unsigned int message, unsigned int flag);
typedef void (*ptr_sr_setlasterr)(long ddd, long error);
typedef long (*ptr_sr_putevt)(long dev, unsigned long evt, long len, void  *datap, long err);


//
// Global variables
//
// SrlFunc contains pointers to functions for all SRL functions

struct func_table SrlFunc[] = {
{ "ATDV_ERRMSGP"   , (func_ptr)sr_null_notimp },
{ "ATDV_IOPORT"    , (func_ptr)sr_long_notimp },
{ "ATDV_IRQNUM"    , (func_ptr)sr_long_notimp },
{ "ATDV_LASTERR"   , (func_ptr)sr_dflt_lasterr},
{ "ATDV_NAMEP"     , (func_ptr)sr_null_notimp },
{ "ATDV_SUBDEVS"   , (func_ptr)sr_long_notimp },
{ "sr_waitevt"     , (func_ptr)sr_long_notimp },
{ "sr_waitevtEx"   , (func_ptr)sr_long_notimp },
{ "sr_enbhdlr"     , (func_ptr)sr_long_notimp },
{ "sr_dishdlr"     , (func_ptr)sr_long_notimp },
{ "sr_getboardcnt" , (func_ptr)sr_long_notimp },
{ "sr_getevtdev"   , (func_ptr)sr_long_notimp },
{ "sr_getevttype"  , (func_ptr)sr_long_notimp },
{ "sr_getevtlen"   , (func_ptr)sr_long_notimp },
{ "sr_getevtdatap" , (func_ptr)sr_null_notimp },
{ "sr_hold"        , (func_ptr)sr_long_notimp },
{ "sr_release"     , (func_ptr)sr_long_notimp },
{ "sr_getparm"     , (func_ptr)sr_long_notimp },
{ "sr_setparm"     , (func_ptr)sr_long_notimp },
{ "sr_NotifyEvent" , (func_ptr)sr_long_notimp },
{ "sr_setlasterr"  , (func_ptr)sr_dflt_setlasterr }, 
{ "sr_putevt"      , (func_ptr)sr_long_notimp } 
};

static char mtlibname[] = "LIBSRLMT.DLL";
// Bhargavp (02/12/99)
// This is regarding the PTR 6075.The user was not compiling with libsrlmt.lib but
// getting pointers  to the major functions. He was specifying DLGC_ST which was mapping
// onto LIBSRL.DLL. Only pblm, no such DLL as LIBSRL.DLL exists; only LIBSRLMT.DLL exists.
// So am changing the #def to LIBSRLMT.DLL and asked the user to use the sr_setparm func.
// static char stlibname[] = "LIBSRL.DLL";
static char stlibname[] = "LIBSRLMT.DLL";
static char *libname;


/**
 ** Functions
 **/
long sr_libinit(unsigned short flag)
{
    struct func_table *srlp = SrlFunc;
    func_ptr ProcAddress;
    static HINSTANCE LibHandle = NULL;
    DWORD filever, prodver;
    DWORD NumberofFunctions;
    unsigned long srlmode = SR_STASYNC;
        
    //
    // check if already open
    //
    if (LibHandle != (HINSTANCE)NULL) {
       return(-1);
    }

    //
    // Determine the library to load
    //
    if ((flag & DLGC_MT) == DLGC_MT) {
       libname = mtlibname;
    } else {
       libname = mtlibname;
       sr_GetDllVersion(&filever, &prodver);
       if (filever <= 0x0004000A) {
          libname = stlibname;
       } 
    }
    NumberofFunctions = sizeof(SrlFunc)/sizeof(SrlFunc[0]);

    //
    // Try and load the SRL library. If no library then set up
    // default entrypoints for each function.
    //
    if ((LibHandle = LoadLibrary(libname)) == (HINSTANCE)NULL) {
       return(0);
    }

    //
    // The library has been loaded. Set up each entry to a default
    // not implemented function and then overwrite the true address if
    // the function is present in the DLL.
    //
    while ( NumberofFunctions-- ) {
       ProcAddress = (func_ptr)GetProcAddress(LibHandle, srlp->fname);
       if (ProcAddress) {
          srlp->fptr = ProcAddress;
       }
       srlp++;
    }

    if ( (flag & DLGC_MT) == DLGC_ST ) {
       sr_setparm(SRL_DEVICE, SR_MODELTYPE, &srlmode);
    }

    return(0);
}


char *ATDV_ERRMSGP( long ddd )
{
    ptr_ATDV_ERRMSGP p;

    p = (ptr_ATDV_ERRMSGP)*SrlFunc[ATDV_ERRMSGP_ID].fptr;
    return( (*p)(ddd) );
}


long ATDV_IOPORT( long ddd )
{
    ptr_ATDV_IOPORT p;

    p = (ptr_ATDV_IOPORT)*SrlFunc[ATDV_IOPORT_ID].fptr; 
    return( (*p)(ddd) );
}


long ATDV_IRQNUM( long ddd )
{
    ptr_ATDV_IRQNUM p;

    p = (ptr_ATDV_IRQNUM)*SrlFunc[ATDV_IRQNUM_ID].fptr;
    return( (*p)(ddd) );
}


long ATDV_LASTERR( long ddd )
{
    ptr_ATDV_LASTERR p;

    p = (ptr_ATDV_LASTERR)*SrlFunc[ATDV_LASTERR_ID].fptr;
    return( (*p)(ddd) ); 
}


char *ATDV_NAMEP( long ddd )
{
    ptr_ATDV_NAMEP p;

    p = (ptr_ATDV_NAMEP)*SrlFunc[ATDV_NAMEP_ID].fptr;
    return( (*p)(ddd) ); 
}


long ATDV_SUBDEVS( long ddd )
{
    ptr_ATDV_SUBDEVS p;

    p = (ptr_ATDV_SUBDEVS)*SrlFunc[ATDV_SUBDEVS_ID].fptr;
    return( (*p)(ddd) ); 
}


long sr_waitevt( long tmout )
{
    ptr_sr_waitevt p;

    p = (ptr_sr_waitevt)*SrlFunc[sr_waitevt_ID].fptr;
    return( (*p)(tmout) );
}


long sr_waitevtEx( long *handlep, int count, long tmout, long *evthp )
{
    ptr_sr_waitevtEx p;

    p = (ptr_sr_waitevtEx)*SrlFunc[sr_waitevtEx_ID].fptr;
    return( (*p)(handlep, count, tmout, evthp) );
}


long sr_enbhdlr( long ddd, unsigned long event_type, long (*hdlr)(unsigned long parm ) )
{
    ptr_sr_enbhdlr p;

    p = (ptr_sr_enbhdlr)*SrlFunc[sr_enbhdlr_ID].fptr;                                        
	 return( (*p)(ddd, event_type, hdlr) );
}


long sr_dishdlr( long ddd, unsigned long event_type, long (*hdlr)(unsigned long parm ) )
{
	 ptr_sr_dishdlr p;

	 p = (ptr_sr_dishdlr)*SrlFunc[sr_dishdlr_ID].fptr;                                                                                   /* Disable an event handler */
	 return( (*p)(ddd, event_type, hdlr) );
}


long sr_getboardcnt( char * brdname, int * brdcnt)
{
    ptr_sr_getboardcnt p;

    p = (ptr_sr_getboardcnt)*SrlFunc[sr_getboardcnt_ID].fptr;
    return( (*p)(brdname, brdcnt) );
}


long sr_getevtdev( unsigned long event)
{
    ptr_sr_getevtdev p;

    p = (ptr_sr_getevtdev)*SrlFunc[sr_getevtdev_ID].fptr;
    return( (*p)(event) );
}


long sr_getevttype( unsigned long evthandle)
{
    ptr_sr_getevttype p;

    p = (ptr_sr_getevttype)*SrlFunc[sr_getevttype_ID].fptr;
    return( (*p)(evthandle) );
}


long sr_getevtlen( unsigned long evthandle)
{
    ptr_sr_getevtlen p;

    p = (ptr_sr_getevtlen)*SrlFunc[sr_getevtlen_ID].fptr;
    return( (*p)(evthandle) );
}


void *sr_getevtdatap( unsigned long evthandle )
{
    ptr_sr_getevtdatap p;

    p = (ptr_sr_getevtdatap)*SrlFunc[sr_getevtdatap_ID].fptr;
    return( (*p)(evthandle) );
}


long sr_hold()
{
    ptr_sr_hold p;

    p = (ptr_sr_hold)*SrlFunc[sr_hold_ID].fptr;
    return( (*p)() );
}


long sr_release()
{
    ptr_sr_release p;

    p = (ptr_sr_release)*SrlFunc[sr_release_ID].fptr;
    return( (*p)() );
}


long sr_getparm( long ddd, long parmid, void* valuep)   
{
    ptr_sr_getparm p;

    p = (ptr_sr_getparm)*SrlFunc[sr_getparm_ID].fptr;
    return( (*p)(ddd, parmid, valuep) );
}


long sr_setparm( long ddd, long parmid, void* valuep ) 
{
    ptr_sr_setparm p;

    p = (ptr_sr_setparm)*SrlFunc[sr_setparm_ID].fptr;
    return( (*p)(ddd, parmid, valuep) );
}


void sr_NotifyEvent(HWND handle, unsigned int message, unsigned int flag)
{   
    ptr_sr_NotifyEvent p;

    p = (ptr_sr_NotifyEvent)*SrlFunc[sr_NotifyEvent_ID].fptr;   
    (*p)(handle, message, flag);
}


void sr_setlasterr(long ddd, long error)
{
    ptr_sr_setlasterr p;

    p = (ptr_sr_setlasterr)*SrlFunc[sr_setlasterr_ID].fptr;
    (*p)(ddd, error);
}

long sr_putevt(long dev, unsigned long evt, long len, void  *datap, long err)
{
    ptr_sr_putevt p;

    p = (ptr_sr_putevt)*SrlFunc[sr_putevt_ID].fptr;
    return ((*p)(dev, evt, len, datap, err));
}	

void sr_dflt_setlasterr( void )
{

}


long sr_dflt_lasterr( void )
{
   return(ESR_NOTIMP);
}


long sr_long_notimp() 
{
    sr_setlasterr(SRL_DEVICE, ESR_NOTIMP);
    return( (long) -1 ); 
}    


char * sr_null_notimp() 
{
    sr_setlasterr(SRL_DEVICE, ESR_NOTIMP);
    return( (char *)NULL ); 
}


long sr_GetDllVersion(LPDWORD fileverp, LPDWORD prodverp)
{
   return(sr_GetVersion(libname, fileverp, prodverp));
}


long sr_GetVersion(char * libnamep, LPDWORD fileverp, LPDWORD prodverp)
{
   DWORD  VerBufferSize;
   LPVOID pVerBuffer;
   UINT bytecnt;
   VS_FIXEDFILEINFO * pvsffi;
   OSVERSIONINFO osinfo;

   *fileverp = 0x0004000A;
   *prodverp = 0x0004000A;
   osinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
   if (GetVersionEx(&osinfo) == TRUE) {
      switch(osinfo.dwPlatformId) {
      case VER_PLATFORM_WIN32_NT:
         // 4.10 is the defaul version number for NT
         break;
      default:
         // 4.11 is the default version for Win/95
         *fileverp = 0x0004000B;
         *prodverp = 0x00010000;
         break;
      }
   }

   if ((VerBufferSize = GetFileVersionInfoSize((LPTSTR)libnamep, (LPDWORD)NULL)) == (DWORD)0) {
      return(0);
   }
   pVerBuffer = (LPVOID)malloc(VerBufferSize);
   if (GetFileVersionInfo((LPTSTR)libnamep, (DWORD)NULL, VerBufferSize, (LPVOID)pVerBuffer) == FALSE) {
      free(pVerBuffer);
      return(0);
   }
   if (VerQueryValue(pVerBuffer, "\\", (void **)&pvsffi, &bytecnt) == 0) {
      free(pVerBuffer);
      return(0);
   }

   *fileverp = pvsffi->dwFileVersionMS;
   *prodverp = pvsffi->dwProductVersionMS;
   free(pVerBuffer);
   return(0);
}

