//
//  Copyright (c) 1999-2003 by AudioCodes USA, Inc.
//  All rights reserved.
//
//  MS_Types.h
//      SmartWORKS API Common type Marco Definitions
//
//  AUDIOCODES USA, INC. PROPRIETARY.
//

#ifndef  _INC_MSTYPES_H
#define  _INC_MSTYPES_H

#ifdef LINUX

typedef char            CHAR;
typedef unsigned char   BYTE;
typedef short           SHORT;
typedef long            LONG;
typedef CHAR *          PCHAR;
typedef BYTE *          LPBYTE;
typedef SHORT *         PSHORT;
typedef LONG *          PLONG;
typedef unsigned char   UCHAR;
typedef unsigned short  USHORT;
typedef unsigned long   ULONG;
typedef ULONG *         PULONG;
typedef USHORT *        PUSHORT;
typedef UCHAR *         PUCHAR;
typedef char *          PSTR;
typedef const PSTR      PCSTR;
typedef wchar_t         WCHAR;
typedef wchar_t *       PWCHAR;
typedef wchar_t *       PWSTR;
typedef const PWSTR     PCWSTR;
typedef const PWSTR     LPCWSTR;
typedef char *          LPTSTR;
typedef const LPTSTR    LPCTSTR;
typedef unsigned short  WORD;
typedef unsigned long   DWORD;
typedef DWORD *         PDWORD;
typedef void            VOID;
typedef VOID *          PVOID;
typedef VOID *          LPVOID;
typedef bool            BOOL;
typedef bool            BOOLEAN;
typedef BOOLEAN *       PBOOLEAN;
typedef BOOL *          PBOOL;
typedef void *          LPARAM;
typedef void *          HINSTANCE;
typedef double          LONGLONG;
typedef unsigned int	DWORD32;
typedef unsigned int *  PDWORD32;
typedef unsigned int    UINT;
typedef unsigned int *  PUINT;
//typedef void *          va_list;


typedef union _LARGE_INTEGER {
    struct {
        DWORD LowPart;
        LONG HighPart;
    } u;
    LONGLONG QuadPart;
} LARGE_INTEGER;

//
//  File System time stamps are represented with the following structure:
//
typedef struct _FILETIME {
    DWORD dwLowDateTime;
    DWORD dwHighDateTime;
} FILETIME, *PFILETIME, *LPFILETIME;

//
// System time is represented with the following structure:
//
typedef struct _SYSTEMTIME {
    WORD wYear;
    WORD wMonth;
    WORD wDayOfWeek;
    WORD wDay;
    WORD wHour;
    WORD wMinute;
    WORD wSecond;
    WORD wMilliseconds;
} SYSTEMTIME, *PSYSTEMTIME, *LPSYSTEMTIME;

// Avoid those that are defined by QT
#ifndef _QT
typedef void *          HANDLE;
#endif

#define FALSE           false
#define TRUE            true

#define NO_ERROR                        0
#define ERROR_NOT_ENOUGH_MEMORY         8L
#define ERROR_INVALID_PARAMETER         87L
#define ERROR_DUP_NAME                  52L
#define E_UNEXPECTED                    0x8000FFFFL

#include <sys/time.h>

#endif

#endif

// End of MS_Types.h
