// -------------------------------------------------------------------------
// File:        VoiceCreator.cpp
//
// Purpose:     These functions are used to map and unmap functions in a
//              Voice DLL into the address of the current process by
//              dynamically loading the DLL at runtime.
//
// Notes:       - This file only needs to be modified if a new function will
//                be exported from ALL board DLLs.
//   -------------------------------------------------------------------------
// #include <stdio.h>
#include <winsock2.h>
#include <windows.h>

#include "VoiceCreator.h"

PVoiceCreator GetVoiceCreator(HINSTANCE library)
{
   PVoiceCreator creatorFunction = NULL;

   if(library != NULL)
   {
      creatorFunction = (PVoiceCreator) GetProcAddress(library, "_CreateVoice");

      if(creatorFunction == NULL)
      {
         creatorFunction = (PVoiceCreator) GetProcAddress(library, "CreateVoice");
      }
   }

   return(creatorFunction);
}

PVoiceDestroyer GetVoiceDestroyer(HINSTANCE library)
{
   PVoiceDestroyer destroyerFunction = NULL;

   if(library != NULL)
   {
      destroyerFunction = (PVoiceDestroyer) GetProcAddress(library, "_DestroyVoice");

      if(destroyerFunction == NULL)
      {
         destroyerFunction = (PVoiceDestroyer) GetProcAddress(library, "DestroyVoice");
      }
   }

   return(destroyerFunction);
}
