#include <stdlib.h>
#include "step_blockcalls.h"
#include "..\BoardDLLs\brd_generic.h"

StepBlockCalls::StepBlockCalls(STEPREC& stepRecord) : Step(stepRecord)
{
}

StepBlockCalls::~StepBlockCalls(void)
{
}

const char* StepBlockCalls::GetStepName(void) const
{
	return("Block Port");
}

// -------------------------------------------------------------------------
//   Name:        StepBlockCalls::Execute
//
//   Purpose:     Blocks any calls from coming in or going out on the current
//                line.
// ------------------------------------------------------------------------- 
IV_STATUS StepBlockCalls::Execute(PIVRINFO pInfo)
{
   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   return(pInfo->ivBoard->BlockCalls());
}
