#include "step_digitpending.h"
#include "..\BoardDLLs\brd_generic.h"

StepDigitPending::StepDigitPending(STEPREC& stepRecord) : Step(stepRecord)
{
   varNm = stepRecord.s1.arr;
}

StepDigitPending::~StepDigitPending(void)
{
}

const char* StepDigitPending::GetStepName(void) const
{
	return("Pending TT");
}

IV_STATUS StepDigitPending::Execute(PIVRINFO pInfo)
{
   char value[2];

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   pInfo->ivBoard->QueryDigit(value[0]);
   value[1] = 0;

   if(!pInfo->variables->Set(varNm.c_str(), value))
   {
      pInfo->ivLog->Print("      ERROR: Failed to set Pending TT variable '%s'\n", varNm.c_str());
      return(IVR_FATAL);
   }

   return(IVR_SUCCESS);
}
