#include "step_varsetprivate.h"

StepVarSetPrivate::StepVarSetPrivate(STEPREC& stepRecord) : Step(stepRecord)
{
   varNm = stepRecord.s1.arr;
   varValue = stepRecord.s6.arr;
}

StepVarSetPrivate::~StepVarSetPrivate(void)
{
}

const char* StepVarSetPrivate::GetStepName(void) const
{
	return("Set Local Variable");
}

IV_STATUS StepVarSetPrivate::Execute(PIVRINFO pInfo)
{
   IV_STATUS status;
   char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->Parse(varValue.c_str())) == NULL)
   {
      pInfo->ivLog->Print("      ERROR: Value '%s' is undefined\n", varValue.c_str());
      return(IVR_FATAL);
   }

   status = pInfo->variables->SetLocal(varNm.c_str(), value) ? IVR_SUCCESS : IVR_FATAL;

   delete[] value;

   return(status);
}
