#include "step_vocrecgetdigits.h"
#include "..\BoardDLLs\brd_generic.h"
#include "..\Voice\Voice.h"

StepVocRecGetDigits::StepVocRecGetDigits(STEPREC& stepRecord) : Step(stepRecord)
{
   noVoiceTimeout = stepRecord.s3.arr;
	thresholdConfidence = stepRecord.s4.arr;
   confidenceVar = stepRecord.s2.arr;
   resultVar = stepRecord.s1.arr;
   handleVar = stepRecord.s6.arr;
   retainAudioOnThreshold = (bool) stepRecord.u1;
}

StepVocRecGetDigits::~StepVocRecGetDigits(void)
{
}

const char* StepVocRecGetDigits::GetStepName(void) const
{
	return("SR Get Digits");
}

void StepVocRecGetDigits::InterpretNumberSpeak(char* string)
{
	char* wordStart = string;
   // char* wordEnd = string;
   char* wordEnd;
   char* writeIndex = string;
   int conjunction = 0;
   int thousandUsed = 0;

   strlwr(string);

   while(*wordStart != '\0')
   {
   	wordEnd = strchr(wordStart, ' ');

      if(wordEnd == NULL)
      {
      	wordEnd = string + strlen(string) - 1;
      }

      if(isdigit(*wordStart))
      {
         *(writeIndex++) = *(wordStart++);
      }
      else
      {
         switch(*(wordStart + 1))
         {
            // "one" "and"
            case 'n':
            {
               switch(*wordStart)
               {
                  // "one"
                  case 'o':
                  {
                     if(conjunction > 0)
                     {
                        writeIndex--;
                     }

                     *(writeIndex++) = '1';

                     conjunction = 0;

                     break;
                  }

                  // "and"
                  case 'a':
                  {
                     // do nothing
                     break;
                  }
               }

               break;
            }

            // "two" "twelve" "twenty"
            case 'w':
            {
               switch(*(wordStart + 3))
               {
                  // "two"
                  case ' ':
                  case '\0':
                  {
                     if(conjunction > 0)
                     {
                        writeIndex--;
                     }

                     *(writeIndex++) = '2';

                     conjunction = 0;

                     break;
                  }

                  // "twelve"
                  case 'l':
                  {
                     if(conjunction > 1)
                     {
                        writeIndex -= 2;
                     }

                     *(writeIndex++) = '1';
                     *(writeIndex++) = '2';

                     conjunction = 0;

                     break;
                  }

                  // "twenty"
                  case 'n':
                  {
                     if(conjunction > 1)
                     {
                        writeIndex -= 2;
                     }

                     *(writeIndex++) = '2';
                     *(writeIndex++) = '0';

                     conjunction = 1;

                     break;
                  }
               }

               break;
            }

            // "oh" "three" "thirteen" "thirty" "thousand"
            case 'h':
            {
               switch(*(wordStart + 2))
               {
                  // "three"
                  case 'r':
                  {
                     if(conjunction > 0)
                     {
                        writeIndex--;
                     }

                     *(writeIndex++) = '3';

                     conjunction = 0;

                     break;
                  }

                  // "thirteen" "thirty"
                  case 'i':
                  {
                     switch(*(wordStart + 5))
                     {
                        // "thirteen"
                        case 'e':
                        {
                           if(conjunction > 1)
                           {
                              writeIndex-= 2;
                           }

                           *(writeIndex++) = '1';
                           *(writeIndex++) = '3';

                           conjunction = 0;

                           break;
                        }

                        // "thirty"
                        case 'y':
                        {
                           if(conjunction > 1)
                           {
                              writeIndex -=2;
                           }

                           *(writeIndex++) = '3';
                           *(writeIndex++) = '0';

                           conjunction = 1;

                           break;
                        }
                     }

                     break;
                  }

                  // "thousand"
                  case 'o':
                  {
                     *(writeIndex++) = '0';
                     *(writeIndex++) = '0';
                     *(writeIndex++) = '0';

                     conjunction = 3;
                     thousandUsed = 3;

                     break;
                  }

                  // "oh"
                  case ' ':
                  case '\0':
                  {
                     if(conjunction > 0)
                     {
                        writeIndex--;
                     }

                     *(writeIndex++) = '0';

                     conjunction = 0;

                     break;
                  }
               }

               break;
            }

            // "four" "fourteen" "forty"
            case 'o':
            {
               switch(*(wordStart + 4))
               {
                  // "four"
                  case ' ':
                  case '\0':
                  {
                     if(conjunction > 0)
                     {
                        writeIndex--;
                     }

                     *(writeIndex++) = '4';

                     conjunction = 0;

                     break;
                  }

                  // "fourteen"
                  case 't':
                  {
                     if(conjunction > 1)
                     {
                        writeIndex -= 2;
                     }

                     *(writeIndex++) = '1';
                     *(writeIndex++) = '4';

                     conjunction = 0;

                     break;
                  }

                  // "forty"
                  case 'y':
                  {
                     if(conjunction > 1)
                     {
                        writeIndex -= 2;
                     }

                     *(writeIndex++) = '4';
                     *(writeIndex++) = '0';

                     conjunction = 1;

                     break;
                  }
               }

               break;
            }

            // "eleven"
            case 'l':
            {
               if(conjunction > 1)
               {
                  writeIndex -= 2;
               }

               *(writeIndex++) = '1';
               *(writeIndex++) = '1';

               conjunction = 0;

               break;
            }

            // "hundred"
            case 'u':
            {
               if(thousandUsed > 0)
               {
                  *(writeIndex - 3) = *(writeIndex - 1);
                  writeIndex -= 2;
               }

               *(writeIndex++) = '0';
               *(writeIndex++) = '0';

               conjunction = 2;

               break;
            }

            // remaining...
            default:
            {
               switch(*(wordStart + 3))
               {
                  // "six" "ten"
                  case ' ':
                  case '\0':
                  {
                     switch(*wordStart)
                     {
                        // "six"
                        case 's':
                        {
                           if(conjunction > 0)
                           {
                              writeIndex--;
                           }

                           *(writeIndex++) = '6';

                           conjunction = 0;

                           break;
                        }

                        // "ten"
                        case 't':
                        {
                           if(conjunction > 1)
                           {
                              writeIndex -= 2;
                           }

                           *(writeIndex++) = '1';
                           *(writeIndex++) = '0';

                           conjunction = 0;

                           break;
                        }
                     }

                     break;
                  }

                  // "five" "seven" "nine" "seventeen" "nineteen" "seventy" "ninety"
                  case 'e':
                  {
                     switch(*wordStart)
                     {
                        // "five"
                        case 'f':
                        {
                           if(conjunction > 0)
                           {
                              writeIndex--;
                           }

                           *(writeIndex++) = '5';

                           conjunction = 0;

                           break;
                        }

                        // "seven" "seventeen" "seventy"
                        case 's':
                        {
                           switch(*(wordStart + 5))
                           {
                              // "seven"
                              case ' ':
                              case '\0':
                              {
                                 if(conjunction > 0)
                                 {
                                    writeIndex--;
                                 }

                                 *(writeIndex++) = '7';

                                 conjunction = 0;

                                 break;
                              }

                              // "seventeen" "seventy"
                              case 't':
                              {
                                 switch(*(wordStart + 6))
                                 {
                                    // "seventeen"
                                    case 'e':
                                    {
                                       if(conjunction > 1)
                                       {
                                          writeIndex -=2;
                                       }

                                       *(writeIndex++) = '1';
                                       *(writeIndex++) = '7';

                                       conjunction = 0;

                                       break;
                                    }

                                    // "seventy"
                                    case 'y':
                                    {
                                       if(conjunction > 1)
                                       {
                                          writeIndex -=2;
                                       }

                                       *(writeIndex++) = '7';
                                       *(writeIndex++) = '0';

                                       conjunction = 1;

                                       break;
                                    }
                                 }

                                 break;
                              }
                           }

                           break;
                        }

                        // "nine" "nineteen" "ninety"
                        case 'n':
                        {
                           switch(*(wordStart + 4))
                           {
                              // "nine"
                              case ' ':
                              case '\0':
                              {
                                 if(conjunction > 0)
                                 {
                                    writeIndex--;
                                 }

                                 *(writeIndex++) = '9';

                                 conjunction = 0;

                                 break;
                              }

                              // "nineteen" "ninety"
                              case 't':
                              {
                                 switch(*(wordStart + 5))
                                 {
                                    // "nineteen"
                                    case 'e':
                                    {
                                       if(conjunction > 1)
                                       {
                                          writeIndex -= 2;
                                       }

                                       *(writeIndex++) = '1';
                                       *(writeIndex++) = '9';

                                       conjunction = 0;

                                       break;
                                    }

                                    // "ninety"
                                    case 'y':
                                    {
                                       if(conjunction > 1)
                                       {
                                          writeIndex -= 2;
                                       }

                                       *(writeIndex++) = '9';
                                       *(writeIndex++) = '0';

                                       conjunction = 1;

                                       break;
                                    }
                                 }

                                 break;
                              }
                           }

                           break;
                        }
                     }

                     break;
                  }

                  // "eight" "eighteen" "eighty"
                  case 'h':
                  {
                     switch(*(wordStart + 5))
                     {
                        // "eight"
                        case ' ':
                        case '\0':
                        {
                           if(conjunction > 0)
                           {
                              writeIndex--;
                           }

                           *(writeIndex++) = '8';

                           conjunction = 0;

                           break;
                        }

                        // "eighteen"
                        case 'e':
                        {
                           if(conjunction > 1)
                           {
                              writeIndex -= 2;
                           }

                           *(writeIndex++) = '1';
                           *(writeIndex++) = '8';

                           conjunction = 0;

                           break;
                        }

                        // "eighty"
                        case 'y':
                        {
                           if(conjunction > 1)
                           {
                              writeIndex -= 2;
                           }

                           *(writeIndex++) = '8';
                           *(writeIndex++) = '0';

                           conjunction = 1;

                           break;
                        }
                     }

                     break;
                  }

                  // "fifteen" "sixteen" "fifty" "sixty"
                  case 't':
                  {
                     switch(*wordStart)
                     {
                        // "fifteen" "fifty"
                        case 'f':
                        {
                           switch(*(wordStart + 4))
                           {
                              // "fifteen"
                              case 'e':
                              {
                                 if(conjunction > 1)
                                 {
                                    writeIndex -= 2;
                                 }

                                 *(writeIndex++) = '1';
                                 *(writeIndex++) = '5';

                                 conjunction = 0;

                                 break;
                              }

                              // "fifty"
                              case 'y':
                              {
                                 if(conjunction > 1)
                                 {
                                    writeIndex -= 2;
                                 }

                                 *(writeIndex++) = '5';
                                 *(writeIndex++) = '0';

                                 conjunction = 1;

                                 break;
                              }
                           }

                           break;
                        }

                        case 's':
                        {
                           switch(*(wordStart + 4))
                           {
                              // "sixteen"
                              case 'e':
                              {
                                 if(conjunction > 1)
                                 {
                                    writeIndex -= 2;
                                 }

                                 *(writeIndex++) = '1';
                                 *(writeIndex++) = '6';

                                 conjunction = 0;

                                 break;
                              }

                              // "sixty"
                              case 'y':
                              {
                                 if(conjunction > 1)
                                 {
                                    writeIndex -= 2;
                                 }

                                 *(writeIndex++) = '6';
                                 *(writeIndex++) = '0';

                                 conjunction = 1;

                                 break;
                              }
                           }

                           break;
                        }
                     }

                     break;
                  }

                  // "zero"
                  case 'o':
                  {
                     if(conjunction > 0)
                     {
                        writeIndex--;
                     }

                     *(writeIndex++) = '0';

                     conjunction = 0;

                     break;
                  }
               }
            }
         }

         if(thousandUsed > 0)
         {
            thousandUsed--;
         }

         wordStart = wordEnd + 1;
      }
   }

   *writeIndex = '\0';
}
// StepVocRecGetDigits::InterpretNumberSpeak

IV_STATUS StepVocRecGetDigits::Execute (PIVRINFO pInfo)
{
	IV_STATUS status;
   char* value;
   // Evaluate all parameters before exiting
   bool bParmsValid = true;
   int iNoVoiceTimeout;
   unsigned int endOfSpeechTimeout = pInfo->ivBoard->GetSREndOfSpeechTimeout();
   char concept[1024];
   unsigned int maxlength = 1023;
   unsigned int confidence;
   unsigned int iThresholdConfidence;

	// String large enough for 0 to 100 %
   char confidenceString[4];

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   if(pInfo->speechRecognition == NULL)
    {
      pInfo->ivLog->Print("      ERROR: No speech recognition module loaded\n");
      pInfo->ivLog->Print("         Make sure to use SR Acquire before SR steps\n");
      return(IVR_FATAL);
   }

   // Get no voice timeout
   if((value = pInfo->variables->ParseParameter("No voice TIMEOUT", noVoiceTimeout.c_str(), "@TIMEOUT")) == NULL)
   {
      bParmsValid = false;
   }
   else
   {
      iNoVoiceTimeout = atoi(value);
      delete[] value;

      if(iNoVoiceTimeout <= 0)
      {
		   pInfo->ivLog->Print("      ERROR: No voice TIMEOUT '%s' must be > 0\n", noVoiceTimeout.c_str());
         bParmsValid = false;
      }
   }

   if(!thresholdConfidence.empty())
   {
      if((value = pInfo->variables->ParseParameter("Threshold confidence", thresholdConfidence.c_str())) == NULL)
      {
         bParmsValid = false;
      }
      else
      {
         iThresholdConfidence = atoi(value);
         delete[] value;
      }
   }
   else
   {
      pInfo->ivLog->Print("      No threshold confidence\n");
   }

   if(!bParmsValid)
   {
      return(IVR_FATAL);
   }

   // Blank out variable to receive digits.
   if(!pInfo->variables->Set(resultVar.c_str(), ""))
   {
   	pInfo->ivLog->Print("      ERROR: Unable to clear Response variable '%s'\n", resultVar.c_str());
      return(IVR_FATAL);
   }

   // Capture SR starting information for SpeechTrainer
   pInfo->speechRecognition->SRCaptureStartStats(pInfo->pszAppFile,      // SR step TAP
                                              GetCurrentStep(),       // SR step number
                                              GetStepName(),          // SR step name
                                              iNoVoiceTimeout,        // no voice t/o (int)
                                              endOfSpeechTimeout,     // end speech t/o (unsigned int)
                                              iThresholdConfidence,   // threshold (unsigned int)
                                              retainAudioOnThreshold, // retainAudio (bool)
                                              Voice::DIGITS,          // grammar type
                                              NULL,                   // base grammar
                                              NULL                    // additional grammar
                                            );

   pInfo->speechRecognition->SRSetAudioFormat(pInfo->ivBoard->GetSRAudioFormat());

   // Start the recogniser and load the grammar
	if(pInfo->speechRecognition->SRLoadGrammar(Voice::DIGITS, NULL) != IVR_SUCCESS)
   {
      pInfo->ivLog->Print("      ERROR: Failed to start speech recognition\n");
   	return(IVR_FAIL);
   }

   // Call board-level AudioRecognise to record and process audio
  	status = pInfo->ivBoard->AudioRecognise(iNoVoiceTimeout, endOfSpeechTimeout);

   if(status != IVR_SUCCESS)
   {
      pInfo->speechRecognition->SREnd();
      pInfo->speechRecognition->SRClearAudio();
   }

   // No voice detected
	if(status == IVR_NO_VOICE)
   {
      char ttDig;

      if((status = pInfo->ivBoard->QueryDigit(ttDig)) != IVR_SUCCESS)
      {
         return(IVR_FATAL);
      }
      // IVR_TIMEOUT for no voice
      else if(ttDig == '\0')
      {
         // SR Result = NO VOICE
         // Capture SR result for SpeechTrainer
         pInfo->speechRecognition->SRCaptureResult('\0',         // no digit
                                               "",           // no concept text
                                               0,            // confidence undefined
                                               IVR_TIMEOUT);  // result

         if(!pInfo->variables->IsEmpty(handleVar.c_str())
            && !pInfo->variables->Set(handleVar.c_str(), pInfo->speechRecognition->SRGetRecognitionHandle()))
         {
            pInfo->ivLog->Print("      ERROR: Failed to set handle variable '%s'\n", handleVar.c_str());
            return(IVR_FATAL);
         }

         return(IVR_TIMEOUT);
      }

      if(!pInfo->variables->IsEmpty(confidenceVar.c_str()))
      {
   	   // Set confidence variable to 0
      	if(!pInfo->variables->Set(confidenceVar.c_str(), "0"))
   	   {
   		   pInfo->ivLog->Print("      ERROR: Failed to set Confidence variable '%s' to '0'\n", confidenceVar.c_str());
	   		return(IVR_FATAL);
   	   }
      }

      // IVR_THRESHOLD for digit
      // SR Result = TT TERMINATION
      // Capture SR result for SpeechTrainer
      pInfo->speechRecognition->SRCaptureResult(ttDig,          // digit
                                            "",             // no concept text
                                            0,              // confidence 0%
                                            IVR_THRESHOLD); // result

      if(!pInfo->variables->IsEmpty(handleVar.c_str())
         && !pInfo->variables->Set(handleVar.c_str(), pInfo->speechRecognition->SRGetRecognitionHandle()))
      {
         pInfo->ivLog->Print("      ERROR: Failed to set handle variable '%s'\n", handleVar.c_str());
         return(IVR_FATAL);
      }

      return(IVR_THRESHOLD);
   }
   // We were unsuccessful with the audio recognition
   else if(status != IVR_SUCCESS)
   {
   	return(status);
   }

   // Get result
   if(pInfo->speechRecognition->SRGetResult(concept, maxlength, confidence) != IVR_SUCCESS)
   {
   	pInfo->ivLog->Print("      ERROR: Failed to get speech recognition result\n");

      // SR Result = SR FAILURE
      // Capture SR result for SpeechTrainer
      pInfo->speechRecognition->SRCaptureResult('\0',           // no digit
                                            "",             // no concept text
                                            0,              // confidence undefined
                                            IVR_FAIL);      // result

      if(!pInfo->variables->IsEmpty(handleVar.c_str())
         && !pInfo->variables->Set(handleVar.c_str(), pInfo->speechRecognition->SRGetRecognitionHandle()))
      {
         pInfo->ivLog->Print("      ERROR: Failed to set handle variable '%s'\n", handleVar.c_str());
         return(IVR_FATAL);
      }

      pInfo->speechRecognition->SRClearAudio();

      return(IVR_FAIL);
   }

   InterpretNumberSpeak(concept);

   pInfo->ivLog->Print("      Got: '%s'\n", concept);

   // Set result variable with concept
   if(!pInfo->variables->Set(resultVar.c_str(), concept))
   {
   	pInfo->ivLog->Print("      ERROR: Failed to set Response variable '%s' with '%s'\n", resultVar.c_str(), concept);
      pInfo->speechRecognition->SRClearAudio();
		return(IVR_FATAL);
   }

	if(!pInfo->variables->IsEmpty(confidenceVar.c_str()))
   {
	   // Write confidence to confidence string
   	sprintf(confidenceString, "%d", confidence);

	   // Set confidence variable with confidence
   	if(!pInfo->variables->Set(confidenceVar.c_str(), confidenceString))
   	{
   		pInfo->ivLog->Print("      ERROR: Failed to set Confidence variable '%s' with '%s'\n", confidenceVar.c_str(), confidenceString);
         pInfo->speechRecognition->SRClearAudio();
			return(IVR_FATAL);
   	}
   }

   // Check threshold confidence
	if(!pInfo->variables->IsEmpty(thresholdConfidence.c_str()))
   {
      // Recognition confidence is less than the minimum or empty string
      if((confidence < iThresholdConfidence) || pInfo->variables->IsEmpty(concept))
      {
         // SR Result = THRESHOLD FAILURE
         // Capture SR result for SpeechTrainer
         pInfo->speechRecognition->SRCaptureResult('\0',           // no digit
                                               concept,        // concept text
                                               confidence,     // confidence
                                               IVR_THRESHOLD); // result

         if(!pInfo->variables->IsEmpty(handleVar.c_str())
            && !pInfo->variables->Set(handleVar.c_str(), pInfo->speechRecognition->SRGetRecognitionHandle()))
         {
            pInfo->ivLog->Print("      ERROR: Failed to set handle variable '%s'\n", handleVar.c_str());
            return(IVR_FATAL);
         }

         if(!retainAudioOnThreshold)
         {
            pInfo->speechRecognition->SRClearAudio();
         }

   	   return(IVR_THRESHOLD);
      }
   }

   // SR Result = THRESHOLD PASSED
   // Capture SR result for SpeechTrainer
   pInfo->speechRecognition->SRCaptureResult('\0',           // no digit
                                         concept,        // concept text
                                         confidence,     // confidence
                                         IVR_SUCCESS);   // result

   if(!pInfo->variables->IsEmpty(handleVar.c_str())
      && !pInfo->variables->Set(handleVar.c_str(), pInfo->speechRecognition->SRGetRecognitionHandle()))
   {
      pInfo->ivLog->Print("      ERROR: Failed to set handle variable '%s'\n", handleVar.c_str());
      return(IVR_FATAL);
   }

   pInfo->speechRecognition->SRClearAudio();

   return(IVR_SUCCESS);
}
// StepVocRecGetDigits::Execute
