#include "TFEngine_communication_manager.h"

TFEngineCommunicationManager::TFEngineCommunicationManager(void)
{
}

void TFEngineCommunicationManager::BroadcastMessage(TFEngineCommunicationPacket* message)
{
   TFEngineCommunicationPacket* newMessage;

   for(map<int, CommunicationDestination<int>*>::iterator pos = destinations.begin();
      pos != destinations.end(); pos++)
   {
      CommunicationHub<int>::mutex.Get();
      newMessage = new TFEngineCommunicationPacket(message->appID, message->event);
      pos->second->SendMessage(newMessage);
      CommunicationHub<int>::mutex.Release();
      Sleep(1);   // Stagger sending of messages to avoid preformance issues,
                  // using minimum sleep time which will be one timeslice
   }

   delete message;
}

TFServerCommunicationPacket::TF_DESTINATION_ID TFEngineCommunicationManager::ID(void)
{
   return(TFServerCommunicationPacket::TF_ENGINE_MANAGER);
}

bool TFEngineCommunicationManager::SendMessage(CommunicationPacket* message)
{
   TFEngineCommunicationPacket* TFEngineMessage = (TFEngineCommunicationPacket*) message;
   bool result;

   if(TFEngineMessage != NULL)
   {
      if(TFEngineMessage->appID == 0)
      {
         BroadcastMessage(TFEngineMessage);
         result = true;
      }
      else
      {
         CommunicationHub<int>::mutex.Get();
         if(destinations.count(TFEngineMessage->appID) == 0)
         {
            delete TFEngineMessage;
            result = false;
         }
         else
         {
            result = destinations[TFEngineMessage->appID]->SendMessage(TFEngineMessage);
         }
         CommunicationHub<int>::mutex.Release();
      }
   }
   else
   {
      result = false;
   }

   return(result);
}
