#ifndef APP_MGR_H
#define APP_MGR_H

#include "..\escutil\link.h"
#include "ivrinfo.h"
#include "..\TFServer\File_Log.h""

/* -------------------------------------------------------------------------
   Class:       IVRApps

   Purpose:     Wrapper class to allow the link list class to be used.  I
                derived from Head to include a locking before attempting to
                access the link list.
   ------------------------------------------------------------------------- */
class IVRApps : public Head
{
public:
   IVRApps(void);
   ~IVRApps(void);
   bool Lock(unsigned long timeout = 0);
   void Unlock(void);
	bool LoadTAL(char* pszFileNm, char* pszLogDir, DWORD dwLogLines, DWORD dwMaxLogFileSize,
      char* pszInstallationPath, HANDLE hLoadingMutex, FileLog* sysLog, HINSTANCE boardLibrary,
      int *pFirstSIPPort = NULL);
private:
   HANDLE  hMutex;
};

/* -------------------------------------------------------------------------
   Class:       IVRApp

   Purpose:     Wrapper class to allow the link list class to be used.
   ------------------------------------------------------------------------- */
class IVRApp : public Link
{
public:
   IVRApp(DWORD dwLogLines, DWORD dwMaxFileSize);
   ~IVRApp(void);

   IVRINFO data;
};

#endif
