#ifndef TFSIMULATOR_COMMUNICATION_H
#define TFSIMULATOR_COMMUNICATION_H

#include "..\TFServer\TFServer_communication.h"


class TFSimulatorCommunicationPacket : public CommunicationPacket
{
   public:

      // Events sent from a thread to the service.
      enum TF_SIMULATOR_EVENT
      {
         TF_SIMULATOR_ON_HOOK,
         TF_SIMULATOR_OFF_HOOK,
         TF_SIMULATOR_READY_FOR_CALL,
         TF_SIMULATOR_NOT_READY_FOR_CALL,
         TF_SIMULATOR_REFRESH,
         TF_SIMULATOR_OUTGOING_CALL,
         TF_SIMULATOR_SET_HWI,
         TF_SIMULATOR_SET_MCI_DEVICE,
         TF_SIMULATOR_SHOW_STOP_RECORDING_BUTTON,
         TF_SIMULATOR_HIDE_STOP_RECORDING_BUTTON,
         TF_SIMULATOR_SHOW_BARGEIN_BUTTON,
         TF_SIMULATOR_HIDE_BARGEIN_BUTTON,
         TF_SIMULATOR_ENABLE_BARGEIN_BUTTON,
         TF_SIMULATOR_DISABLE_BARGEIN_BUTTON
      };

      TFSimulatorCommunicationPacket(TF_SIMULATOR_EVENT event, int appID);
      ~TFSimulatorCommunicationPacket(void);

      const char* GetEventName(void);
      static const char* GetEventName(TFSimulatorCommunicationPacket::TF_SIMULATOR_EVENT event);

      TF_SIMULATOR_EVENT event;
      // Application ID of the sending engine
      int appID;
      int eventInfo;
      char status;
      int stepNumber;
      char* stepName;
      char* TAMName;
};

// Note that messages must be TFServerCommunicationPackets
// Messages for the server must use TF_SERVER as their destination
class TFSimulatorCommunicationDestination : public CommunicationDestination<TFServerCommunicationPacket::TF_DESTINATION_ID>
{
   public:

      TFSimulatorCommunicationDestination(void);

      TFServerCommunicationPacket::TF_DESTINATION_ID ID(void);
};

#endif
