#ifndef PARMLIST_H
#define PARMLIST_H

#if defined(__DLL__)
#define PARMLISTAPI __declspec(dllexport)
#else
#define PARMLISTAPI
// __declspec(dllimport)
#endif

/* -------------------------------------------------------------------------
   ------------------------------------------------------------------------- */
class PARMLISTAPI ParameterList
{
public:
   ParameterList();
   ~ParameterList();
   void ClearParmList();
   void SetList (const char *pszValue);
   bool AddParm (const char *pszName, const char *pszValue);
   bool RemoveParm (const char *pszName);
   int GetParmCount();
   bool GetParmByName (const char *pszName, char *&pszValue);
   bool GetParmByNumber (int parmNo, char *&pszName, char *&pszValue);
   void DumpList();
private:
   char  *pszList;       // Ptr to the PARAMETER=VALUE list.
   int    listSize;      // Size of pszList.
   char  *pszMyParm;     // Temporary variable for use with GetParmByXXX.
   int    myParmSize;    // Size of pszMyParm.
   char  *pszMyValue;    // Temporary variable for use with GetParmByXXX.
   int    myValueSize;   // Size of pszMyValue.

   char  *pszSOL;         // Ptr to the start of line.

   bool GetParm();
};

#undef PARMLISTAPI

#endif
