#include <stdlib.h>                 // atoi
#include <ctype.h>                  // isdigit

#include "SMTPResponse.h"

SMTPResponse::SMTPResponse(void)
{
}

SMTPResponse::~SMTPResponse(void)
{
}

void SMTPResponse::LoadLastResponse(void)
{
   string::size_type lastResponseBegin;
   string::size_type lastResponseEnd;

   if(((lastResponseEnd = text.rfind("\r\n")) == string::npos) || (lastResponseEnd < 2))
   {
      responseText = text;
      return;
   }

   if((lastResponseBegin = text.substr(0, lastResponseEnd - 2).rfind("\r\n")) == string::npos)
   {
      responseText = text.substr(0, lastResponseEnd + 2);
      return;
   }

   responseText = text.substr(lastResponseBegin + 2, lastResponseEnd);
}

SMTPResponse::STATUS_CODE SMTPResponse::GetStatusCode(void)
{
   LoadLastResponse();

   if((responseText.length() < 5) || !isdigit(responseText[0]) || !isdigit(responseText[1]) || !isdigit(responseText[2]))
   {
      return(INVALID_STATUS);
   }

   return((SMTPResponse::STATUS_CODE) atoi(responseText.substr(0, 3).c_str()));
}

const char* SMTPResponse::GetResponseText(void)
{
   string::size_type length;

   LoadLastResponse();

   if((length = responseText.length()) <= 4)
   {
      return("");
   }

   responseText = responseText.substr(4, length - 4);

   return(responseText.c_str());
}

bool SMTPResponse::HaveCompleteMessage(void)
{
   LoadLastResponse();
   return((responseText.length() >= 5) && (responseText[3] != '-') && (responseText.find("\r\n") != string::npos));
}


